from Ornatrix.QtImport import *
from ..Container.HostNode import *
from NodeConfig import NodeConfig


class Result(object):
	def __init__(self, node, pinId):
		self.node = node
		self.pinId = pinId


class BaseBridge(QtCore.QObject):
	dataChangedEvent = QtCore.Signal(int)

	hostNode = {}

	preWrappedNode = {}
	preWrappedHairSystem = {}

	def __init__(self):
		super(BaseBridge, self).__init__()
		self._container = None

	@property
	def container(self):
		return self._container

	@container.setter
	def container(self, container):
		self._container = container

	def getHostInput(self, inputName):
		matchingHostInput = []
		for input in self.inputConnectionMapper.iteritems():
			if input[1] == inputName:
				matchingHostInput.append(input[0])
		return matchingHostInput

	def registerHostNode(self, name, config):
		configBase = {'input': [], 'output': []}
		configBase.update(config)
		nodeConfig = NodeConfig(name, configBase)
		self.hostNode[name] = nodeConfig

	def getHostNode(self, canBeCreated = False):
		if canBeCreated:
			canBeCreatedList = {}
			for key, node in self.hostNode.iteritems():
				if node.canBeCreated():
					canBeCreatedList[key] = node
			return canBeCreatedList
		return self.hostNode

	def deleteNode(self, node):
		node._deleted = True
		for hs in self.preWrappedHairSystem.itervalues():
			hs.clean()


	def dataChanged(self):
		self.dataChangedEvent.emit(0)

	def clear(self):
		self.preWrappedHairSystem = {}
		self.preWrappedNode = {}

	###
	### Common Converter
	###
