from .BaseBridge import *


class EmulatedNode(object):
	def __init__(self, name, type, attr=[]):
		self.name = name
		self.type = type
		self.attr = attr

		self.posX = 0
		self.posY = 0


class EmulatedBridge(BaseBridge):

	def __init__(self, container):
		self.emulatedNode = {}

		def addNode(node):
			self.emulatedNode[node.name] = node

		addNode(EmulatedNode('HairShape1', 'HairShape', ['inputGuides']))
		addNode(EmulatedNode('HairFromGuidesNode1', 'HairFromGuidesNode', ['inputGuides', 'outputHair']))
		addNode(EmulatedNode('EditGuidesShape1', 'EditGuidesShape', ['inputGuides', 'outputGuides']))
		addNode(EmulatedNode('GuidesFromMeshNode1', 'GuidesFromMeshNode', ['inputMesh', 'outputGuides']))
		addNode(EmulatedNode('mesh1', 'mesh', ['outMesh']))

		self.emulatedConnection = {}
		self.emulatedConnection['HairShape1'] = [['inputGuides', 'HairFromGuidesNode1', 'outputHair']]
		self.emulatedConnection['HairFromGuidesNode1'] = [['inputGuides', 'EditGuidesShape1', 'outputGuides']]
		self.emulatedConnection['EditGuidesShape1'] = [['inputGuides', 'GuidesFromMeshNode1', 'outputGuides']]
		self.emulatedConnection['GuidesFromMeshNode1'] = [['inputMesh', 'mesh1', 'outMesh']]

	def getOrnatrixNode(self):
		ornatrixNodeList = []
		nodes = self.emulatedNode
		for key in nodes:
			node = self.emulatedNode[key]
			nodeInfo = {}
			nodeInfo['name'] = node.name
			nodeInfo['type'] = node.type
			nodeInfo['selected'] = False
			nodeInfo['enabled'] = True
			ornatrixNodeList.append(nodeInfo)
		return ornatrixNodeList

	def setSelection(self, name, add=False):
		pass

	def createNode(self, type, posX, posY):
		pass

	def getOrnatrixConnections(self, node):
		list = []
		if node in self.emulatedConnection:
			conns = self.emulatedConnection[node]
			if conns:
				for x in conns:
					list.append(x)
		return list

	def disconnect(self, inputNode, inputPlug, outputNode, outputPlug):
		pass

	def connect(self, inputNode, inputPlug, outputNode, outputPlug):
		pass

	def getOrCreateNodePosition(self, nodeName):
		return [self.emulatedNode[nodeName].posX, self.emulatedNode[nodeName].posY]

	def setNodePosition(self, nodeName, x, y):
		self.emulatedNode[nodeName].posX = x
		self.emulatedNode[nodeName].posY = y

	def hasAttribute(self, nodeName, plug):
		if nodeName in self.emulatedNode and plug in self.emulatedNode[nodeName].attr:
			return True
		return False
