from Ornatrix.QtImport import *
import weakref


class OrnatrixContainer(QtCore.QObject):

	uiRegistered = QtCore.Signal(str, object)

	def __init__(self):
		super(OrnatrixContainer, self).__init__()
		self.currentHairSystem = 0
		self.__editor = None

		self.ui = {}
		self.callBack = {}

	def update(self):
		self.bridge.dataChanged()

	def registerUI(self, uiName, ui):
		self.ui[uiName] = ui
		self.uiRegistered.emit(uiName, ui)
		print 'ui registered : ', uiName
		for key, cb in self.callBack.iteritems():
			if cb[0] == uiName:
				cb[1](ui, uiName, False)


	def uiRegisterCallback(self, object, uiName, callBack):
		self.callBack[object] = [uiName, callBack]
		if uiName in self.ui:
			callBack(self.ui[uiName], uiName, False)


	@property
	def bridge(self):
		return self._bridge

	@bridge.setter
	def bridge(self, bridge):
		bridge.container = self
		self._bridge = bridge

	@property
	def editor(self):
		return self.__editor()

	@editor.setter
	def editor(self, editor):
		self.__editor = weakref.ref(editor)
