from NodeContainer import *

class HairSystemNode(NodeContainer):

	def __init__(self, name):
		super(HairSystemNode, self).__init__(name)

		self._isHostNode = False
		self._hostNode = None
		self.selected = False
		self._parent = None

		self.datas = {}
		self.setPos(0, 0)

	####
	##
	####

	def setPos(self, x, y):
		self.setData("pos", {"x": x, "y": y})

	def getPos(self):
		return self.getData("pos", {"x": 0, "y": 0})

	def isHostNode(self):
		return self.type == "hostNode"

	def setHostNode(self, hostNode):
		self._isHostNode = True
		self._hostNode = hostNode

	def getHostNode(self):
		return self._hostNode

	def getBaseType(self):
		return self.type

	def getBaseType(self):
		if self.isHostNode():
			return self.getHostNode().getBaseType()
		return self.type

	# Check if the node still exist in the Host
	def isValid(self):
		return True

	def isSelected(self):
		if self.isHostNode():
			return self.getHostNode().selected
		return False


	def parent(self):
		if self.isHostNode():
			return self.getHostNode().getParent()
		return self._parent

	####
	## Arbitrary Data
	####

	def setData(self, key, value):
		self.datas[key] = value

	def getData(self, key, default):
		if key not in self.datas:
			self.datas[key] = default
		return self.datas[key]

	def getDatas(self):
		return self.datas

	def setDatas(self, datas):
		self.datas = datas


	####
	##  Misc
	####

	def icon(self):
		if self.isHostNode():
			return self._hostNode.icon
		return None

	def __repr__(self):
		return "HairSystemNode::" + self.name