from NodeContainer import *

class HostNode(NodeContainer):

	def __init__(self, name, path):
		super(HostNode, self).__init__(name)
		self.path = path
		self.typeApi = []
		self.enabled = False

		self.inputs = []
		self.outputs = []

		self.computeTime = 0

		self.outputConn = {}

	def toggleNode(self):
		self.container.bridge.toggleNode(self)

	###
	### Utility Gathering
	###
	def getSupportedInput(self):
		return self.inputs

	def getSupportedOutput(self):
		return self.outputs

	def getBaseType(self):
		return self.config.getType()

	def supportState(self):
		if self.type in ["operator", "layer"]:
			return True
		return False

	def getNodeAbove(self, id=0):
		return self.container.bridge.getNodeAbove(self, id)

	def getNodeUnder(self, id=0):
		return self.container.bridge.getNodeUnder(self, id)

	def isBaseShape(self):
		return False

	def isTopShape(self):
		return False

	def getParent(self):
		return self.container.bridge.getParent(self)

	def getChilds(self):
		return self.container.bridge.getChilds(self)


	###
	### Setup Function
	###

	def addInput(self, inputName, supportedType):
		self.inputs.append([inputName, supportedType])

	def getInputs(self):
		return self.inputs

	def addOutputConnection(self, outputId, destinationNode, destInputId):
		self.outputConn[outputId] = [destinationNode, destInputId]

	def addOutput(self, outputName, outputType):
		self.outputs.append([outputName, outputType])

	# Check if the node still exist in the Host
	def isValid(self):
		return self.container.bridge.nodeExist(self)

	def toJSON(self):
		data = super(HostNode, self).toJSON()
		return data

	def __repr__(self):
		return "HostNode::" + self.path