from Ornatrix.QtImport import *

class Breadcrumb(QtWidgets.QLabel):
	def __init__(self, container):
		super(Breadcrumb, self).__init__()
		self.container = container
		self.container.uiRegisterCallback(self, "graph", self.setupGraph)


		self.setTextFormat(QtCore.Qt.RichText)
		self.setTextInteractionFlags(QtCore.Qt.TextBrowserInteraction)
		self.linkActivated.connect(self.linkClicked)


	def setupGraph(self, graph, uiName, isRegistering):
		self.graph = graph
		graph.sceneUpdated.connect(self.update)
		self.update()

	def update(self):
		path = ['root']
		if self.graph.parent:
			path.append(self.graph.parent.name)

		str = ""
		for k in range(0, len(path)):
			l = path[k]
			if k >= len(path) - 1:
				str += " >> " + l
			else:
				str += " >> <a href=\"" + l + "\">" + l + "</a>"
		self.setText(str)

	def linkClicked(self, link):
		if link == "root":
			self.graph.setParent(None)
