from Ornatrix.QtImport import *


class ConnectionContextMenu(QtWidgets.QMenu):
	def __init__(self, connection, event):
		super(ConnectionContextMenu, self).__init__()

		self.connection = connection
		self.container = connection.container
		self.ev = event

		action = QtWidgets.QAction("break connection", self)
		action.setData(["special", "break"])
		self.addAction(action)

		nodes = self.container.bridge.getHostNode()
		for key, config in nodes.iteritems():
			if config.canBeCreated():
				action = QtWidgets.QAction(key, self)
				action.setData(["node", key])
				if config.getIcon():
					action.setIcon(config.getIcon())
				# action.triggered.connect(lambda key=key: self.newNode(key))
				self.addAction(action)

		action = QtWidgets.QAction("Group", self)
		action.setData(["special", "group"])
		self.addAction(action)

		result = self.exec_(event.screenPos())
		if result:
			if result.data()[0] == "node":
				self.insertNode(result.data()[1])
			if result.data()[0] == "special":
				if result.data()[1] == "break":
					self.breakConnection()


	def insertNode(self, nodeType):
		node = self.container.bridge.createNode(nodeType)

		if self.container.ui['graph'].parent:
			self.container.bridge.setParent(node, self.container.ui['graph'].parent.getHostNode())

		hairNode = self.container.ui['graph'].hairSystem.insertHostNode(node)
		hairNode.setPos(self.ev.scenePos().x(), self.ev.scenePos().y())

		above = self.connection.getDestPin().node.nodeContainer.getHostNode()
		aboveId =  self.connection.getDestPin().id
		below = self.connection.getSourcePin().node.nodeContainer.getHostNode()
		belowId = self.connection.getSourcePin().id
		self.container.bridge.disconnectNode(below, above, aboveId, belowId)
		self.container.bridge.connectNode(below, node, 0, belowId)
		self.container.bridge.connectNode(node, above, aboveId, 0)


	def breakConnection(self):
		self.container.connectionManager.doDisconnect(self.connection)
