from Ornatrix.QtImport import *

from .OxGraph import OxScene
from .GraphView import GraphView
from .GraphMenu import GraphMenu


class GraphEditor(QtWidgets.QWidget):
	def __init__(self, container, parent=None):
		super(GraphEditor, self).__init__()

		self.container = container

		self.buildUI()
		self.updateUI()

	def buildUI(self):

		layout = QtWidgets.QVBoxLayout()

		self.graphView = GraphView()
		self.oxScene = OxScene(self.container)

		self.menu = GraphMenu(self.container)
		layout.addWidget(self.menu)

		# self.oxggraphScene.newSelection.connect(self.selectionChanged)
		self.graphView.setScene(self.oxScene)
		layout.addWidget(self.graphView)

		self.noGraphWidget = QtWidgets.QWidget()
		self.noGraphWidget.setLayout(QtWidgets.QVBoxLayout())
		self.noGraphWidget.setSizePolicy(QtWidgets.QSizePolicy.Preferred, QtWidgets.QSizePolicy.Expanding)
		self.noGraphWidget.layout().addWidget(QtWidgets.QLabel('No Graph'))
		layout.addWidget(self.noGraphWidget)

		self.setLayout(layout)

	def updateUI(self):
		self.menu.updateUI()
		hairSystems = self.container.bridge.getHairSystem()
		if len(hairSystems) == 0:
			self.graphView.hide()
			self.noGraphWidget.show()
		else:
			self.graphView.show()
			self.noGraphWidget.hide()
			self.oxScene.update()
