from Ornatrix.QtImport import *


class GraphView(QtWidgets.QGraphicsView):

	def __init__(self):
		super(GraphView, self).__init__()
		# self.setMinimumHeight(600)
		# self.setMinimumWidth(400)
		self.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAlwaysOff)
		self.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAlwaysOff)
		#self.setDragMode(QtWidgets.QGraphicsView.ScrollHandDrag)

	def keyPressEvent(self, event):
		event.accept()
		if event.key() == 76:
			self.scene().autoLayout()

	def enterEvent(self, event):
		super(GraphView, self).enterEvent(event)
		self.viewport().setCursor(QtCore.Qt.CrossCursor)



	def mousePressEvent(self, event):
		self.viewport().setCursor(QtCore.Qt.CrossCursor)
		if event.button() == QtCore.Qt.MidButton:
			self.__prevMousePos = event.pos()
		else:
			super(GraphView, self).mousePressEvent(event)

	def mouseMoveEvent(self, event):
		self.viewport().setCursor(QtCore.Qt.CrossCursor)
		if event.buttons() == QtCore.Qt.MidButton:
			offset = self.__prevMousePos - event.pos()
			self.__prevMousePos = event.pos()

			self.verticalScrollBar().setValue(self.verticalScrollBar().value() + offset.y())
			self.horizontalScrollBar().setValue(self.horizontalScrollBar().value() + offset.x())
		else:
			super(GraphView, self).mouseMoveEvent(event)

	def paintEvent(self, paint):
		super(GraphView, self).paintEvent(paint)
		painter = QtGui.QPainter(self.viewport())
		painter.setRenderHints(self.renderHints())
		painter.drawText(QtCore.QRectF(10, 10, 200, 20), "Eval Time : " +
		                 str(float(self.scene().totalTime) / 1000) + " s")

	def wheelEvent(self, event):
		if event.delta() > 0:
			self.scale(1.1, 1.1)
		elif event.delta() < 0:
			self.scale(0.9, 0.9)
