from Ornatrix.QtImport import *


class Button(QtWidgets.QGraphicsObject):
	onClicked = QtCore.Signal()

	baseColor = QtCore.Qt.darkRed
	connectedColor = QtCore.Qt.red

	def __init__(self, parentNode):
		super(Button, self).__init__(parent=parentNode)

		# in parent coords
		self.setPos(QtCore.QPoint(0, 0))
		self.size = 8

	def boundingRect(self):
		boundingRect = QtCore.QRectF(-self.size, -self.size, self.size * 2, self.size * 2)
		return boundingRect

	def mousePressEvent(self, event):
		if event.button() == QtCore.Qt.LeftButton:
			if self.boundingRect().contains(QtCore.QPoint(event.pos().x(), event.pos().y())):
				self.onClicked.emit()

	def paint(self, painter, option, widget):
		painter.setRenderHint(QtGui.QPainter.Antialiasing)
		painter.setRenderHint(QtGui.QPainter.SmoothPixmapTransform)
		color = self.baseColor

		if self.parentItem().isEnabled():
			color = QtCore.Qt.green

		brush = QtGui.QBrush(color)
		painter.setBrush(brush)
		path = QtGui.QPainterPath()
		path.moveTo(-1, 10)
		path.arcTo(-6, 0, 10, 10, 270, -90)
		path.lineTo(-6, -5)
		path.arcTo(-6, -10, 10, 10, 180, -90)
		path.lineTo(-1, 10)
		painter.drawPath(path)
		painter.fillPath(path, color)
		# NodeName

		brush = QtGui.QBrush(QtGui.QColor(0, 0, 0), QtCore.Qt.SolidPattern)
		brush.setColor(QtGui.QColor(0, 0, 0))
		painter.setBrush(brush)
		painter.setPen(QtGui.QPen(QtCore.Qt.white, 2, QtCore.Qt.SolidLine, QtCore.Qt.RoundCap, QtCore.Qt.RoundJoin))
		painter.setFont(QtGui.QFont("Times", 10, QtGui.QFont.Bold))
