from Ornatrix.Graph.Editor.Graph.Node.HostNode import *

from Ornatrix.Graph.Editor.Graph.Node.PinPainterCircle import *


class MeshNode(HostNode):
	nodeColor = QtGui.QColor(80, 80, 80)
	defaultPainter = PinPainterCircle()

	def __init__(self, node):
		super(MeshNode, self).__init__(node)

	def configure(self):
		super(MeshNode, self).configure()

	def paint(self, painter, option, widget):
		painter.setRenderHint(QtGui.QPainter.Antialiasing)
		painter.setRenderHint(QtGui.QPainter.SmoothPixmapTransform)

		brush = QtGui.QBrush(self.nodeColor, QtCore.Qt.SolidPattern)

		if self.borderOverrided:
			self.nodePen.setColor(self.penColorOverride)
		elif self.isSelected():
			self.nodePen.setColor(QtGui.QColor(0, 255, 255))
		else:
			self.nodePen.setColor(QtGui.QColor(100, 100, 100))

		painter.setBrush(brush)
		painter.setPen(self.nodePen)

		painter.drawEllipse(QtCore.QRect(-self.width / 2, -self.height / 2, self.width, self.height))

		if self.icon is not None:
			painter.drawPixmap(QtCore.QRectF(-self.width / 2 + 10, -20, 40, 40), self.icon,
			                   QtCore.QRectF(0, 0, self.icon.size().width(), self.icon.size().height()))

		# NodeName
		brush = QtGui.QBrush(QtGui.QColor(0, 0, 0), QtCore.Qt.SolidPattern)
		brush.setColor(QtGui.QColor(0, 0, 0))
		painter.setBrush(brush)
		painter.setPen(QtGui.QPen(QtCore.Qt.white, 1, QtCore.Qt.SolidLine, QtCore.Qt.RoundCap, QtCore.Qt.RoundJoin))
		painter.drawText(QtCore.QRectF(self.width / 2 + 10, -10, 140, 20), self.name)
		self.textBB = painter.boundingRect(QtCore.QRectF(self.width / 2 + 10, -10, 140, 20), 0, self.name)
