from Ornatrix.Graph.Editor.Graph.Node.NodeDB.OperatorNode import *
from Ornatrix.Graph.Editor.Graph.Node.NodeDB.MeshNode import *
from Ornatrix.Graph.Editor.Graph.Node.NodeDB.SpecialNode import *
from Ornatrix.Graph.Editor.Graph.Node.NodeDB.OutputNode import *
from Ornatrix.Graph.Editor.Graph.Node.NodeDB.PackedNetworkNode import *

from Ornatrix.Graph.Editor.Graph.Node.NodeDB.GroupBox import *


from Ornatrix.Graph.Container.NodeContainer import *

from Ornatrix.Graph.Util.Singleton import *
import uuid

@Singleton
class NodeFactory(object):
	nodeLibrary = {}

	def __init__(self):
		self.setNewNode('operator', OperatorNode)
		self.setNewNode('output', OutputNode)
		self.setNewNode('special', SpecialNode)
		self.setNewNode('mesh', MeshNode)
		self.setNewNode('group', GroupBox)
		self.setNewNode('layer', PackedNetworkNode)

	def setNewNode(self, baseType, Nclass):
		self.nodeLibrary[baseType] = Nclass

	def buildNode(self, node, editor):
		if node.getBaseType() in self.nodeLibrary:
			newNode = self.nodeLibrary[node.getBaseType()](node)
			newNode.editor = editor
			return newNode

	def newGroup(self):
		specialNode = NodeContainer("group")
		specialNode.type = "group"
		specialNode.uid = str(uuid.uuid4())
		return specialNode