from Ornatrix.Graph.Editor.Graph.Node.HostNode import *


class PackedNetworkDummieNode(HostNode):
	nodeColor = QtGui.QColor(200, 50, 100)

	def __init__(self, node, isInput = False):
		self.isInput = isInput
		super(PackedNetworkDummieNode, self).__init__(node)


		if isInput:
			self.name = self.nodeContainer.name + "_Output"
			self.setPos(self.nodeContainer.getData("inputDumX", 0), self.nodeContainer.getData("inputDumY", 0))
		else:
			self.name = self.nodeContainer.name + "_Input"
			self.setPos(self.nodeContainer.getData("outputDumX", 0), self.nodeContainer.getData("outputDumY", 0))


	def mouseDoubleClickEvent(self, event):
		self.scene().setParent(self)
		event.accept()

	def itemChange(self, change, val):
		if change == QtWidgets.QGraphicsItem.GraphicsItemChange.ItemPositionChange:
			if self.isInput:
				self.nodeContainer.setData("inputDumX", val.x())
				self.nodeContainer.setData("inputDumY",  val.y())
			else:
				self.nodeContainer.setData("outputDumX", val.x())
				self.nodeContainer.setData("outputDumY",  val.y())
			return val
		return super(Node, self).itemChange(change, val)

	#PackedNetworkNode need to be configured differently than a regular node,
	def configure(self):
		if self.isInput:
			input = self.nodeContainer.getHostNode().getSupportedInput()[1]
			inputPin = Pin(1, input[0], True, self)
			inputPin.setAcceptedType(input[1])
			self.addPin(inputPin)
		else:
			output = self.nodeContainer.getHostNode().getSupportedOutput()[1]
			outputPin = Pin(1, output[0], False, self)
			outputPin.setType(output[1])
			self.addPin(outputPin)