from Ornatrix.Graph.Editor.Graph.Node.HostNode import *


class PackedNetworkNode(HostNode):
	nodeColor = QtGui.QColor(77, 77, 77)

	height = 100
	width = 100

	def __init__(self, node):
		super(PackedNetworkNode, self).__init__(node)


	def mouseDoubleClickEvent(self, event):
		self.scene().setParent(self.nodeContainer)
		event.accept()

	#PackedNetworkNode need to be configured differently than a regular node,
	def configure(self):
		input = self.nodeContainer.getHostNode().getSupportedInput()[0]
		inputPin = Pin(0, input[0], True, self)
		inputPin.setAcceptedType(input[1])
		self.addPin(inputPin)

		output = self.nodeContainer.getHostNode().getSupportedOutput()[0]
		outputPin = Pin(0, output[0], False, self)
		outputPin.setType(output[1])
		self.addPin(outputPin)

		if self.nodeContainer.getHostNode().supportState():
			self.hideButton = Button(self)
			self.hideButton.setPos(-self.width / 2, 0)
			self.hideButton.onClicked.connect(self.toggleEnable)

