from Ornatrix.QtImport import *
from Ornatrix.Graph.Util.Enumeration import *

pinPosition = Enumeration('None Top Bottom Right')
pinType = Enumeration('None LeftCorner Center RightCorner Full')



class PinPainter(object):
	@staticmethod
	def fullPinShape(pin, node = None):
		path = QtGui.QPainterPath()
		baseY = pin.height / 2
		width = node.width / 2
		if pin.isOutput():
			baseY -= 10
			path.moveTo(0, baseY)
			path.lineTo(- width / 2, baseY)
			path.arcTo(-width, 0 + baseY, 30, 30, 90, 65)
			y = path.currentPosition().y()
			path.arcTo(width - 30, 0 + baseY, 30, 30, 25, 55)
			path.lineTo(0, baseY)
		else:
			path.moveTo(0, baseY)
			path.lineTo(- width / 2, baseY)
			path.arcTo(-width, -30 + baseY, 30, 30, 265, -55)
			y = path.currentPosition().y()
			path.arcTo(width - 30, -30 + baseY, 30, 30, -30, -55)
			path.lineTo(0, baseY)
		return path

	@staticmethod
	def leftHalfPinShape(pin, node = None):
		path = QtGui.QPainterPath()
		baseY = pin.height / 2
		if pin.isOutput():
			baseY -= 10
			path.moveTo(0, baseY)
			path.arcTo(-30, 0 + baseY, 30, 30, 90, 60)
			y = path.currentPosition().y()
			path.lineTo(15, y)
		else:
			path.moveTo(15, baseY)
			path.arcTo(-15, -30 + baseY, 30, 30, 270, -60)
			y = path.currentPosition().y()
			path.lineTo(15, y)
		return path

	@staticmethod
	def RightHalfPinShape(pin, node = None):
		path = QtGui.QPainterPath()
		baseY = pin.height / 2
		if pin.isOutput():
			baseY -= 10
			path.moveTo(15, baseY)
			path.arcTo(0, 0 + baseY, 30, 30, 30, 55)
			y = path.currentPosition().y()
			path.lineTo(0, y)
		else:
			path.moveTo(-15, baseY)
			path.arcTo(-15, -30 + baseY, 30, 30, 270, 60)
			y = path.currentPosition().y()
			path.lineTo(-15, y)
		return path
