from Ornatrix.QtImport import *
from Ornatrix.Graph.Util.Enumeration import *

pinPosition = Enumeration('None Top Bottom Right')
pinType = Enumeration('None LeftCorner Center RightCorner Full')


class PinPainterCircle(object):
	@staticmethod
	def fullPinShape(pin, node = None):
		width = pin.parentItem().width
		path = QtGui.QPainterPath()
		baseY = pin.height / 2
		if pin.isOutput():
			baseY -= 9.5
			path.moveTo(0, -baseY)
			path.arcTo(-(width / 2), baseY, width, width, 135, -90)
			y = path.currentPosition().y()
			path.lineTo(0, -baseY)
		else:
			baseY -= 1
			path.moveTo(0, -baseY)
			path.arcTo(-(width / 2), -(width) + baseY, width, width, -45, -90)
			path.lineTo(0, -baseY)
		return path

	@staticmethod
	def leftHalfPinShape(pin, node = None):
		path = QtGui.QPainterPath()
		baseY = pin.height / 2
		if pin.isOutput():
			baseY -= 10
			path.moveTo(0, baseY)
			path.arcTo(-30, 0 + baseY, 30, 30, 90, 60)
			y = path.currentPosition().y()
			path.lineTo(15, y)
		else:
			path.moveTo(15, baseY)
			path.arcTo(-15, -30 + baseY, 30, 30, 270, -60)
			y = path.currentPosition().y()
			path.lineTo(15, y)
		return path

	@staticmethod
	def RightHalfPinShape(pin, node = None):
		path = QtGui.QPainterPath()
		baseY = pin.height / 2
		if pin.isOutput():
			baseY -= 10
			path.moveTo(15, baseY)
			path.arcTo(0, 0 + baseY, 30, 30, 30, 55)
			y = path.currentPosition().y()
			path.lineTo(0, y)
		else:
			path.moveTo(-15, baseY)
			path.arcTo(-15, -30 + baseY, 30, 30, 270, 60)
			y = path.currentPosition().y()
			path.lineTo(-15, y)
		return path
