from Ornatrix.QtImport import *


class NodeContextMenu(QtWidgets.QMenu):
	def __init__(self, node, pos):
		super(NodeContextMenu, self).__init__()

		self.node = node
		action = QtWidgets.QAction("delete", self)
		action.setData("delete")
		self.addAction(action)

		result = self.exec_(pos)
		if result:
			if result.data() == "delete":
				self.deleteNode()

	def deleteNode(self):
		hostNode = self.node.nodeContainer.getHostNode()
		bridge =  self.node.nodeContainer.getHostNode().container.bridge
		bridge.startUndo()
		above = bridge.getNodeAbove(hostNode)
		below = bridge.getNodeUnder(hostNode)
		if len(above):
			bridge.disconnectNode(hostNode, above[0])
		bridge.deleteNode(hostNode)
		if len(below) and len(above):
			bridge.connectNode(below[0], above[0])
		bridge.endUndo()
		bridge.doChange()
