from Ornatrix.QtImport import *


class NodeCreationGrid(QtWidgets.QListWidget):

	def __init__(self, container):
		super(NodeCreationGrid, self).__init__()

		self.setFlow(QtWidgets.QListView.LeftToRight);
		self.setResizeMode(QtWidgets.QListView.Adjust);
		self.setGridSize(QtCore.QSize(48, 48));
		self.setSpacing(0);
		self.setViewMode(QtWidgets.QListView.IconMode);

		nodes = container.bridge.getHostNode()
		for key, config in nodes.iteritems():
			if config.canBeCreated():
				newItem = QtWidgets.QListWidgetItem()
				if config.getIcon():
					newItem.setIcon(config.getIcon())
				newItem.setText(key[:5])
				newItem.setData(QtCore.Qt.UserRole, key)
				self.addItem(newItem)

	def mimeData(self, items):
		mime = super(NodeCreationGrid, self).mimeData(items)
		mime.setText("newnode" + items[0].data(QtCore.Qt.UserRole))
		return mime