from Ornatrix.QtImport import *

class StackModelGraphPlugin(object):

	def __init__(self, stack):
		self.stack = stack

	def setGraph(self, graph):
		self.graph = graph

	def rebuildGraph(self):
		self.graph.update()

	def findConnection(self, nodeList):
		connResult = set()
		for node in nodeList:
			conns = node.getConnector()
			for conn in conns:
				if conn.getSourceNode() == node:
					goal = conn.getDestNode()
				else:
					goal = conn.getSourceNode()
				if goal in nodeList:
					connResult.add(conn)
		return connResult


	def onGraphPreRebuild(self):
		pass

	def onGraphPostRebuild(self):
		matchingNode = []
		for node in self.graph.nodeList.itervalues():
			node.borderOverrided = False
			if node.nodeContainer.isHostNode() and self.stack.nodeInStack(node.nodeContainer.getHostNode()):
				matchingNode.append(node)
		conns = self.findConnection(matchingNode)

		for conn in conns:
			conn.colorOverride = QtGui.QColor(255, 255, 255)