from Ornatrix.QtImport import *

from .StackView import StackView
from .StackModel import StackModel

from IconDelegate import IconDelegate
from TableViewEventFilter import TableViewEventFilter


class StackEditor(QtWidgets.QWidget):
	iconDelegate = IconDelegate()

	def __init__(self, container, parent=None):
		super(StackEditor, self).__init__()
		self.container = container

		self.setSizePolicy(QtWidgets.QSizePolicy.Preferred, QtWidgets.QSizePolicy.Expanding)

		vbox = QtWidgets.QVBoxLayout()

		# Setup StackView
		self.stackView = StackView(self.container)

		self.model = StackModel(self.container)
		self.stackView.setModel(self.model)



		self.stackView.setDropIndicatorShown(True)
		eventFilter = TableViewEventFilter(self)
		self.stackView.installEventFilter(eventFilter)
		self.stackView.setDragEnabled(True)
		self.stackView.setDragDropMode(QtWidgets.QAbstractItemView.InternalMove)

		self.stackView.setColumnWidth(0, 30)
		self.stackView.setColumnWidth(1, 30)

		self.stackView.setItemDelegateForColumn(0, self.iconDelegate)
		self.stackView.setItemDelegateForColumn(1, self.iconDelegate)

		self.stackView.setContextMenuPolicy(QtCore.Qt.CustomContextMenu)

		# Done SetupStackView

		vbox.addWidget(self.stackView)

		self.setLayout(vbox)



	def update(self):
		self.model.update()
		self.stackView.update()