import json
import os

from Ornatrix.QtImport import *

class MayaBridgeLoader(object):

	def __init__(self, bridge):
		self.bridge = bridge

	def load(self, filepath):
		self.filepath = filepath

		__location__ = os.path.realpath(
			os.path.join(os.getcwd(), os.path.dirname(__file__)))
		config = open(__location__ + filepath)
		self.jsonConf = json.load(config)

		self.templates = self.jsonConf['Templates']

		for key, node in self.jsonConf["Nodes"].iteritems():
			self.registerHostNode(key, node)

	def registerHostNode(self, name, config):
		if "template" in config:
			copyNode = self.templates[config["template"]]
			copyNode.update(config)
			config = copyNode
		configBase = {
			'icon': self.getNodeIcon(name),
		}
		configBase.update(config)
		self.bridge.registerHostNode(name, configBase)


	def getNodeIcon(self, node):
		iconName = "Ornatrix" + node[:-4]
		pix = QtGui.QPixmap(":/icons/" + iconName)
		if pix.isNull() == False:
			return pix
		iconName = "Ornatrix" + node
		pix = QtGui.QPixmap(":/icons/" + iconName)
		if pix.isNull() == False:
			return pix
		iconName = "Ornatrix" + node[:-5]
		pix = QtGui.QPixmap(":/icons/" + iconName)
		if pix.isNull() == False:
			return pix
		return QtGui.QPixmap(":/icons/OrnatrixLogo.png")