from .QtImport import *

import maya.cmds as mc
import maya.mel as mel
import maya.OpenMayaUI as mui

shelfName = "OrnatrixGraph"
ornatrixMenu = mc.menu("OrnatrixGraph", parent="MayaWindow", label="Ornatrix", tearOff=True)


def addShelfButton(shelfName, menuName, label, annotation, image, command):
	baseCommand = "import Ornatrix.MayaUtility as omu\n" \
	              "omu." + command
	mc.shelfButton(
		parent=shelfName,
		label=label,
		annotation=annotation,
		image="ornatrix/" + image,
		style="iconOnly",
		stp="python",
		command=baseCommand
	)
	'''mc.menuItem(
		parent = menuName,
		label = label,
		annotation = annotation,
		image = image,
		command = command
	)'''


def createMayaShelf():
	currentVersion = mc.pluginInfo("Ornatrix", q=True, version=True)
	if mc.shelfLayout(shelfName, exists=True):
		if mc.optionVar(q="OrnatrixVersion") == currentVersion and mc.menu("MayaWindow|" + shelfName, q=True,
		                                                                   exists=True):
			return
		fullName = mc.shelfLayout(shelfName, q=True, fullPathName=True)
		mc.deleteUI(fullName)

		if mc.menu("MayaWindow|" + shelfName, q=True, exists=True):
			mc.deleteUI(menu="MayaWindow|" + shelfName)

	gShelfTopLevel = mel.eval("global string $gShelfTopLevel; $temp = $gShelfTopLevel;")
	mc.optionVar(stringValue=("OrnatrixVersion", currentVersion))
	ornatrixMenu = mc.menu(shelfName, parent="MayaWindow", label=shelfName, tearOff=True)
	ornatrixShelf = mc.shelfLayout(shelfName, parent=gShelfTopLevel, annotation=shelfName + currentVersion)
	mc.setParent(gShelfTopLevel)

	# addShelfButton(ornatrixShelf, ornatrixMenu, "Add Hair", "Add Hair to Selection", "OrnatrixQuickHair.png", "OxAddHairToSelection");
	# addShelfButton(ornatrixShelf, ornatrixMenu, "Frizz", "Add Frizz", "OrnatrixFrizz.png", "insertNode('FrizzNode')");

	addShelfButton(ornatrixShelf, ornatrixMenu, "Graph", "Open Graph", "OrnatrixHairStack.png", "openGraph()");


def deleteMayaShelf():
	print "deleting UI"
	if mc.shelfLayout(shelfName, q=True, exists=True):
		fullName = mc.shelfLayout(shelfName, q=True, fullPathName=True)
		mc.deleteUI(fullName)
	if mc.menu("MayaWindow|" + shelfName, q=True, exists=True):
		mc.deleteUI("MayaWindow|" + shelfName, menu=True)
