from .vendor.Qt import QtWidgets
from .vendor.Qt import QtCore
from .vendor.Qt import QtGui

__app = QtWidgets.QApplication.instance()
__window = {o.objectName(): o for o in __app.topLevelWidgets()}["MayaWindow"]


def getMainWindow():
	return __window


def getMayaWidget(path):
	parent = __window
	for child in path.split("|")[1:]:
		parent = parent.findChild(QtCore.QObject, child)
	return parent


def clearLayout(layout):
	if layout != None:
		while layout.count():
			child = layout.takeAt(0)
			if child.widget() is not None:
				child.widget().deleteLater()
			elif child.layout() is not None:
				clearLayout(child.layout())
