import Ornatrix.Global as oxgg
import maya.cmds as mc

from MayaBridge import *

bridge = MayaBridge()

requiredAttribute = [
	['distributionMesh', 1, 'mesh'],
	['distributionMeshMatrix', 1, 'matrix'],
]


def daisyChainStack(targetNode):
	if targetNode.type == "mesh":
		return
	for req in requiredAttribute:
		if not mc.attributeQuery(req[0], node=targetNode.path, exists=True):
			if req[1]:
				mc.addAttr(targetNode.path, ln=req[0], dt=req[2])
			else:
				mc.addAttr(targetNode.path, ln=req[0], at=req[2])
	resultNodes = bridge.getNodeUnder(targetNode)
	for resultNode in resultNodes:
		daisyChainStack(resultNode)
		bridge.disconnectNode(resultNode, targetNode)
		bridge.connectNode(resultNode, targetNode)


def convertStackToV25():
	hairShapeNodes = bridge.getAllOxNode("HairShape")
	for hairShape in hairShapeNodes:
		daisyChainStack(hairShape)
