import maya.cmds as mc

from Ornatrix.vendor.Qt import QtWidgets
from Ornatrix.vendor.Qt import QtCore
from Ornatrix.vendor.Qt import QtGui

from SimpleSeEditor import *
import maya.OpenMayaUI as mui


# Main AETemplate Widget
################################################################################
class AESeExprType(QtWidgets.QWidget):
	def __init__(self, attributePath, parent=None):
		super(AESeExprType, self).__init__(parent)
		self.attributePath = attributePath

		self.editBtn = QtWidgets.QPushButton("Open Expression Editor")
		self.editBtn.clicked.connect(self.openEditor)

		########################################################################
		# Layout
		########################################################################
		self.layout = QtWidgets.QBoxLayout(QtWidgets.QBoxLayout.TopToBottom, self)
		self.layout.setContentsMargins(5, 3, 11, 3)
		self.layout.setSpacing(5)
		self.layout.addWidget(self.editBtn)

		self.refresh()

	def openEditor(self):
		if int(mc.about(api=True)) < 201700:
			self.openSimpleEditor()
		else:
			mc.OxSeExpr(ap=self.attributePath)

	def openSimpleEditor(self):
		mainWin = getMainWindow()
		simpleEditor = SimpleSeEditor(mainWin)
		simpleEditor.setPath(self.attributePath)
		simpleEditor.show()

	def setAttributePath(self, attributePath):
		self.attributePath = attributePath

	def refresh(self):
		res = mc.getAttr(self.attributePath)


def buildQT(lay, attributePath, enabled):
	# get the layout object
	widget = getMayaWidget(lay)
	# create the GUI/widget
	widg = AESeExprType(attributePath)

	# add the widget to the layout
	widget.layout().addWidget(widg)
	mc.OxSeExpr(ap=attributePath, bc=True, e=enabled)


def updateQT(lay, attributePath, enabled):
	# get the layout
	widget = getMayaWidget(lay)
	layout = widget.layout()

	# find the widget
	for c in range(layout.count()):
		widg = layout.itemAt(c).widget()
		if isinstance(widg, AESeExprType):
			# found the widget, update the node it's pointing to
			widg.setAttributePath(attributePath)
			widg.refresh()
			break
	mc.OxSeExpr(ap=attributePath, bc=True, e=enabled)
