from Ornatrix.QtImport import *

import maya.cmds as mc


class SimpleSeEditor(QtWidgets.QDialog):

	def __init__(self, parent=None):
		super(SimpleSeEditor, self).__init__(parent)

		self.setWindowTitle("Simple Expression Editor")

		vbox = QtWidgets.QVBoxLayout()
		self.setLayout(vbox)
		self.edit = QtWidgets.QTextEdit()
		self.apply = QtWidgets.QPushButton("Apply")
		self.apply.clicked.connect(self.pushExpression)
		self.layout().addWidget(self.edit)
		self.layout().addWidget(self.apply)

	def setPath(self, path):
		self._path = path
		expression = mc.getAttr(path)
		self.edit.setText(expression)

	def pushExpression(self):
		expression = self.edit.toPlainText()
		mc.setAttr(self._path, expression, type="string");
